package jp.co.bbreak.sokusen._5._2;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class SafeSample {
	public static void main(String[] args) {

		// 날짜１은 1989/03/10입니다. 
		Calendar cal1 = Calendar.getInstance();
		cal1.set(1989, Calendar.MARCH, 10);
		Date date1 = cal1.getTime();
		// 날짜2는 2020/06/20입니다.
		Calendar cal2 = Calendar.getInstance();
		cal2.set(2020, Calendar.JUNE, 20);
		Date date2 = cal2.getTime();
		
		Thread thread1 = new Thread(() -> {
			// 스레드별로 포맷을 준비합니다
			DateFormat dateFormat1 = new SimpleDateFormat("yyyy/MM/dd");
			for (int i = 0; i < 100; i++) {
				try {
					String result = dateFormat1.format(date1);
					System.out.println("Thread1: " + result);
				} catch (Exception e) {
					e.printStackTrace();
					break;
				}
			}
		});
		
		Thread thread2 = new Thread(() -> {
			// 스레드별로 포맷을 준비합니다 
			DateFormat dateFormat2 = new SimpleDateFormat("yyyy/MM/dd");
			for (int i = 0; i < 100; i++) {
				try {
					String result = dateFormat2.format(date2);
					System.out.println("Thread2: " + result);
				} catch (Exception e) {
					e.printStackTrace();
					break;
				}
			}
		});
		
		System.out.println("스레드 세이프해진 프로그램 검증을 시작합니다.");
		thread1.start();
		thread2.start();

	}

}